option explicit

' ---- Change this constant for a new block! ----
Const blockstart = 12860
Const blockinterval = 20
' --------------------------------------

Const exefilename = "w422f.exe"

dim NTSystem, shell, fso, cmdfilename, logfilename

On Error Resume Next

set shell = wscript.createobject("wscript.shell")
set fso = wscript.createobject("scripting.filesystemobject")
logfilename = "w" & cstr(blockstart) & ".log"

NTSystem = RunningOnNT 
If NTSystem Then
  cmdfilename = "wondrous.cmd"
Else
  cmdfilename = "wondrous.bat"
End If

makecmdfile NTSystem
If err.Number <> 0 then
  msgbox err.description, vbexclamation, wscript.scriptname
else
  shell.run cmdfilename
end if

wscript.quit

'------------------------------
Sub makecmdfile(Byval NTSystem) 

dim ts
dim i, ch, lastline, s1, s2, s3
dim start, finish
dim startcount, finishcount, loopcount
dim Message, procspeed, calcdays

On error resume next
set ts = fso.opentextfile(logfilename)
if err <> 0 then   ' -- New block, start from scratch
  start = blockstart & "000000000000"
  If not NTSystem Then
    Message = "Warning: you are starting the program on a non-NT system." & VBNewLine
    Message = Message & "Since the program can not be started in idle priority" & VbNewLine
    Message = Message & "performance of normal applications on your system could be affected" 
    Message = Message & " (this message wil disappear automatically in 60 seconds)" 
    Shell.Popup Message, 60, "Class Record Search", VBExclamation
  End If
  ShowDuration 
else               ' -- Read last number from file
  do
    s1 = ts.readline
    If Len(Trim(s1)) > 0 Then
      lastline = s1
    End If
  loop until ts.atendofstream
  s2 = ""
  for i = 1 to len(lastline)
    ch = mid(lastline,i,1)
    if isnumeric (ch) then
      s2 = s2 & ch
    end if
    if not isnumeric(ch) and ch <> "," and len(s2) > 0 then
      exit for
    end if
  next 
  ts.close
  start = s2
end if
on error goto 0

  ' ---- Calculate new loopcount
finish = (clng(blockstart) + clng(blockinterval) ) * 1.0e+12
startcount  = int( cdbl(start ) / (2.0^32) )
finishcount = int( cdbl(finish) / (2.0^32) )
loopcount = finishcount - startcount + 2

  ' ---- Create batchfile
set ts = fso.createtextfile(cmdfilename, True)
if loopcount > 0 then
  s3 = "start /min "
  If NTSystem Then
    s3 = s3 & " /low " 
  End If
  s3 = s3 & exefilename & " /o /c" & cstr(loopcount) & " /f" & logfilename & " " & start
  ts.writeline s3
end if
ts.close

end sub

Function RunningOnNT
  Dim NTVersionKey, v
  NTVersionKey = "HKLM\Software\Microsoft\Windows NT\CurrentVersion\CurrentVersion"
  On Error Resume Next
  Err.Clear
  v = shell.RegRead(NTVersionKey)
  RunningOnNT = (Err.Number = 0)
End Function

Sub ShowDuration
  ' -- Show info about length of calculation
  Dim Message, procspeed, calcdays
  On Error Resume Next
  procspeed = shell.regread("HKLM\hardware\description\system\centralprocessor\0\~Mhz")  
  If Err.Number = 0 then
    calcdays = cint (920.0 * blockinterval / procspeed)
    Message = "Calculation time on this machine will probably take around "
    Message = Message & calcdays & " days" & vbNewLine
    Message = Message & " (this message wil disappear automatically in 30 seconds)" 
    Shell.PopUp Message, 30, "Class Record Search", VBInformation
  Else
    Err.Clear
  End if
End Sub

' ---- end of script ----

